
import struct
import serial
# from crccheck import …



class CyanBus:

  header = b'fxCyan'

  @staticmethod
  def makePacket(payload: bytes) -> bytes:
    'Wraps the payload in the standardized `fxCyan`-envelope'

    length = struct.pack('>H', len(payload))  # format = big-endian uint16_t
    crc = CyanBus.crc(payload)

    return CyanBus.header + length + payload + crc

  @staticmethod
  def crc(data: bytes) -> bytes:
    'Calculates and returns the CRC sum of the data'

    # TODO: implement!
    return bytes.fromhex('1337AA1337')

  @staticmethod
  def sendRawPacket(data: bytes, port='/dev/ttyUSB0', baud=115200):
    with serial.Serial(port=port, baudrate=baud, bytesize=8, stopbits=serial.STOPBITS_ONE) as ser:
      ser.write(data)
      ser.flush()
      ser.send_break(0.001)  # time in seconds o.O

  @staticmethod
  def sendPacket(payload: bytes, port='/dev/ttyUSB0', baud=115200):
    data = CyanBus.makePacket(payload)
    CyanBus.sendRawPacket(data, port=port, baud=baud)
